/*********************************************************************
// created:    2007/04/12 - 16:30

//
// author:     Elie Al Alam & Gerald Dherbomez
//
// version:    $Id: DbtPlyVtgManager.cpp 676 2008-06-26 10:33:57Z gdherbom $
//
// purpose:    Dbite Player GGA Manager implementation
*********************************************************************/

#include "DbtPlyVtgManager.h"

#include <cmath>
#include <qapplication.h>

#include "Pacpus/kernel/ComponentManager.h"

namespace pacpus {

//////////////////////////////////////////////////////////////////////////
// Construction de la fabrique de composant DbtPlyVtgManager
//////////////////////////////////////////////////////////////////////////
static ComponentFactory<DbtPlyVtgManager> sFactory("DbtPlyVtgManager");

// double dist1[2];
// double dist2[2];

//////////////////////////////////////////////////////////////////////////
// Constructor
//////////////////////////////////////////////////////////////////////////
DbtPlyVtgManager::DbtPlyVtgManager(QString name)
    : DbtPlyFileManager (name)
{

}

//////////////////////////////////////////////////////////////////////////
// Destructor
DbtPlyVtgManager::~DbtPlyVtgManager()
{

}

//////////////////////////////////////////////////////////////////////////
// Processes data
void DbtPlyVtgManager::processData(road_time_t t, road_timerange_t tr , void * buf)
{
    val = (trame_vtg*)(buf);

    // make local copy of VTG frame
    memcpy(&mVtg.frame, val, sizeof(trame_vtg));
    mVtg.time = t;
    mVtg.timerange = tr;

    // send VTG data to output
    checkedSend(outVtg, mVtg);

}

ComponentBase::COMPONENT_CONFIGURATION DbtPlyVtgManager::configureComponent(XmlComponentConfig config)
{
    DbtPlyFileManager::configureComponent(config);

    return ComponentBase::CONFIGURED_OK;
}

void DbtPlyVtgManager::startActivity()
{
  DbtPlyFileManager::startActivity();
  outVtg = getTypedOutput<TimestampedVtgFrame, DbtPlyVtgManager>("vtg");
  // user interface
}

void DbtPlyVtgManager::stopActivity()
{
  DbtPlyFileManager::stopActivity();
}


/************************************************************************
 * Called by the framework at initialization
 ************************************************************************/
void DbtPlyVtgManager::addInputs()
{
  // uncomment to add an input
}


/************************************************************************
 * Called by the framework at initialization
 ************************************************************************/
void DbtPlyVtgManager::addOutputs()
{
  // empty: no output
  addOutput<TimestampedVtgFrame, DbtPlyVtgManager>("vtg");
}
} // namespace pacpus
